package handles

import (
	"fmt"
	"github.com/gorilla/mux"
	"github.com/louisevanderlith/droxolite/mix"
	"github.com/louisevanderlith/droxolite/security/roletype"
	"github.com/rs/cors"
	"net/http"
	"strings"
)

func SetupRoutes(host, scrt, secureUrl string) http.Handler {
	r := mux.NewRouter()

	/*
		artlCtrl := &controllers.ArticleController{}
		artlGroup := routing.NewRouteGroup("article", mix.JSON)
		artlGroup.AddRoute("Create Article", "", "POST", roletype.Admin, artlCtrl.Post)
		artlGroup.AddRoute("Update Article", "", "PUT", roletype.Admin, artlCtrl.Put)
		artlGroup.AddRoute("Article By Key", "/{key:[0-9]+\x60[0-9]+}", "GET", roletype.Unknown, artlCtrl.GetByKey)
		artlGroup.AddRoute("Delete Article", "/{key:[0-9]+\x60[0-9]+}", "DELETE", roletype.Admin, artlCtrl.Delete)
		artlGroup.AddRoute("All Published Articles", "/all/{pagesize:[A-Z][0-9]+}", "GET", roletype.Unknown, artlCtrl.Get)
		artlGroup.AddRoute("All Published Articles By Category", "/all/{category:[a-zA-Z]+}/{pagesize:[A-Z][0-9]+}", "GET", roletype.Unknown, artlCtrl.GetByCategory)
		artlGroup.AddRoute("All Articles", "/all/non/{pagesize:[A-Z][0-9]+}", "GET", roletype.Unknown, artlCtrl.GetNonPublic)
		e.AddBundle(artlGroup)*/




	corsOpts := cors.New(cors.Options{
		AllowedOrigins: []string{fmt.Sprintf("https://*%s", strings.TrimSuffix(host, "/"))}, //you service is available and allowed for this base url
		AllowedMethods: []string{
			http.MethodGet,
			http.MethodPost,
			http.MethodOptions,
			http.MethodHead,
		},
		AllowCredentials: true,
		AllowedHeaders: []string{
			"*", //or you can your header key values which you are using in your application
		},
	})

	return corsOpts.Handler(r)
}
